#include <math.h>
#include <immintrin.h>

// P(x) = 3 * x^2 + x - 2

void polynomial_sequential ( float low, float high, float step ) {
    for ( float x = low; x <= high; x += step ) {
        float value = 3 * x * x + x - 2;
    }
}

void polynomial_vectorized ( float low, float high, float step ) {
    int number_steps = ( int ) ( ( high - low ) / step );
    
    int overflow = number_steps % 8;
    
    for ( int i = 0; i < number_steps - overflow; i += 8 ) {
        __m256 x_vector = _mm256_set_ps (
            ( i + 7 ) * step + low,
            ( i + 6 ) * step + low,
            ( i + 5 ) * step + low,
            ( i + 4 ) * step + low,
            ( i + 3 ) * step + low,
            ( i + 2 ) * step + low,
            ( i + 1 ) * step + low,
            ( i + 0 ) * step + low
        );
        
        __m256 x_squared_vector = _mm256_mul_ps ( x_vector, x_vector );
        
        __m256 result = _mm256_mul_ps (
            x_squared_vector,
            _mm256_set1_ps ( 3 )
        );
        
        result = _mm256_add_ps (
            result,
            x_vector
        );
        
        result = _mm256_sub_ps (
            result,
            _mm256_set1_ps ( 2 )
        );
    }
}
